unit Kriz3A;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

const
  Vyska = 36;
  Sirka = 43;
  Odsazeni = 8;
  VelikostPisma = 20;
  MaxPRadek = 25;
  MaxPSloupcu = 25;
  MaxDelka = 25; {maximalni delka slova k krizovce}
  Oddelovac = 10; {cislo znaku v ASCII kodu, ktere bude slouzit k oddeleni slov ve slovniku}
  JmenoSlovniku = 'cz.dic';
  Abeceda = ['a'..'z', 'A'..'Z'];
  CeskaAbeceda = ['a'..'z', 'A'..'Z', '', '', '', '', '', '', '', '',
                  '', '', '', '', '', '', '', '', '', '', '', '',
                  '', '', '', '', '', '', '', '', '', ''];
  BPuvodni = clWhite;
  BLegenda = clAqua;
  BTajenka = clRed;
  BPolTaj = clYellow;
  BKrizTaj = clLime;

type
  MString = String[MaxDelka];
  PSlovo = ^TSlovo;
  TSlovo = record
      s: MString; {slovo max. delky 25}
     {p: boolean; {p = true ... jiz bylo v krizovce pouzito}
      d: PSlovo   {ukazatel na dalsi prvek}
      end;
  TPolicko = record
      z: char;    {pismeno v krizovce}
      k: integer  {kolik slov ho potrebuje - 0, 1, nebo 2}
      end;
  PLegenda = ^TLegenda;
  TLegenda = record
      radek: integer; {radek, kde je umistena legenda}
      sloupec: integer; {sloupec, kde je umistena legenda}
      delka: integer; {delka slova, ktere legenda uvozuje}
      zbyva: integer; {kolik pismen slova zbyva doplnit}
      doprava: boolean; {doprava = true ... slovo smeruje doprava}
      ukazobsah: PSlovo; {pointer na slovo ve slovniku}
     {index: integer; {cislo slova v retezci slov urcite delky}
      predchozi: PLegenda; {ukazatel na predchozi legendu}
      dalsi: PLegenda {ukazatel na dalsi legendu}
      end;
  TForm1 = class(TForm)
    Vyrob: TStaticText;
    Uvod: TGroupBox;
    lbRadek: TLabel;
    lbVelikost: TLabel;
    lbSloupcu: TLabel;
    scRadek: TScrollBar;
    scSloupcu: TScrollBar;
    lbPRadek: TLabel;
    lbPSloupcu: TLabel;
    lbDoporuceni: TLabel;
    lbDoporuceni1: TLabel;
    lbOvladani: TLabel;
    lbOvladani1: TLabel;
    lbOvladani2: TLabel;
    Vytvor: TButton;
    procedure FormCreate(Sender: TObject);
    procedure VyrobDblClick(Sender: TObject);
    function KontrolaModrychPoli: boolean;
    function KontrolaSlov: boolean;
    procedure VytvorClick(Sender: TObject);
    procedure Nelze(Sender: TObject);
    procedure NelzeTaky(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
    procedure VytvorPrazdnou(Sender: TObject);
    procedure scRadekChange(Sender: TObject);
    procedure scSloupcuChange(Sender: TObject);
  private
    { Private declarations }
    P: array [0..MaxPRadek-1, 0..MaxPSloupcu-1] of TStaticText;
    procedure ZacniSlovo(Sender: TObject);
    procedure Zpet(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PRadek: integer;
  PSloupcu: integer;
  Zacatek: array [1..MaxDelka] of PSlovo; {ukazatele na zacatky seznamu slov}
  Konec: array [1..MaxDelka] of PSlovo; {ukazatele na posledni prvky seznamu slov}
  Pocet: array [1..MaxDelka] of longint; {pocty slov jednotlivych delek}
  Chyba: boolean; {Chyba = false ... pri priprave slovniku dosud nebyla chyba }

implementation

uses KrizB;

{$R *.DFM}

{************ O V L A D A N I   U V O D N I H O   D I A L O G U ***************}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {uvodni nastaveni}
  PRadek := 10;
  PSloupcu := 10;
  scRadek.Max := MaxPRadek;
  scSloupcu.Max := MaxPSloupcu;
  Chyba := False;
  Form1.Caption := 'Vyrobna krizovek - uvodni volby'
end;

procedure TForm1.scRadekChange(Sender: TObject);
begin
    {zmeni pocet radku krizovky}
    lbPRadek.Caption := IntToStr(scRadek.Position)
end;

procedure TForm1.scSloupcuChange(Sender: TObject);
begin
    {zmeni pocet sloupcu krizovky}
    lbPSloupcu.Caption := IntToStr(scSloupcu.Position)
end;

{****************** Z O B R A Z E N I   K R I Z O V K Y
                   A   P R I P R A V A   S L O V N I K U **********************}

procedure PridejKon (NoveSlovo: String);
{vlozi NoveSlovo do noveho prvku na konec spravneho seznamu}
var Novy: PSlovo;
    DelkaNS: integer;
begin
    DelkaNS := Length(NoveSlovo);
    If DelkaNS <= 0 then
    begin
        If not Chyba then
            ShowMessage('Chyba slovniku!!! Prazdne slovo!');
        Chyba := True;
        Exit
    end;
    If DelkaNS > MaxDelka then
        Exit;
    Novy := new(PSlovo);
    Novy^.s := NoveSlovo;
    Novy^.d := NIL;
    If Konec[DelkaNS] = NIL then
    begin {vlozi prvni prvek do seznamu}
        Konec[DelkaNS] := Novy;
        Zacatek[DelkaNS] := Konec[DelkaNS];
        Pocet[DelkaNS] := 1
    end
    else {vlozi prvek na konec seznamu}
    begin
        If Konec[DelkaNS]^.d <> NIL then
        begin
           If not Chyba then
               ShowMessage('Chyba programu!!!! Nevkladam slovo ze slovniku na konec seznamu!');
           Chyba := True;
           Exit
        end;
        Konec[DelkaNS]^.d := Novy;
        Konec[DelkaNS] := Konec[DelkaNS]^.d;
        Pocet[DelkaNS] := Pocet[DelkaNS] + 1
    end
end;

function VelkaPismena(Nak: char): char;
begin
   Case Nak of
   'a'..'z': VelkaPismena := UpCase(Nak);
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   '': VelkaPismena := '';
   else
      VelkaPismena := Nak;
   end
end;

procedure PripravSlovnik;
var i: integer;
    Slovo: string;
    Slovnik: text;
    Znak: char;
    Delka: integer; {delka ctenych slov ze slovniku}
    MaxSlovo: integer; {maximalni delka slova zvolena uzivatelem}
begin
    {pripravi si promenne}
    For i := 1 to MaxDelka do
    begin
       Zacatek[i] := NIL;
       Konec[i] := NIL;
       Pocet[i] := 0
    end;
    If PSloupcu > PRadek then
       MaxSlovo := PSloupcu - 1
    else
       MaxSlovo := PRadek - 1;
    Delka := 0;

    {otevre soubor pro cteni}
    {$I-}
    Assign(Slovnik, JmenoSlovniku);
    Reset(Slovnik);
    {$I+}
    If IOResult <> 0 then
    begin
        ShowMessage('Chyba!!! Nenasel jsem slovnik ' + JmenoSlovniku + '!');
        Halt
    end;

    {nacte ze slovniku patricna slova}
    While (Delka <= MaxSlovo) and (not EOF(Slovnik)) do
    begin
        Slovo := '';
        Read(Slovnik, Znak);
        While Ord(Znak) <> Oddelovac do
        begin
            Slovo := Slovo + VelkaPismena(Znak);
            Read(Slovnik, Znak)
        end;
        PridejKon(Slovo);
        Delka := Length(Slovo)
    end;

    {zavre soubor}
    Close(Slovnik);
    For i := 1 to MaxDelka do
       Konec[i] := NIL
end;

procedure TForm1.VytvorClick(Sender: TObject);
begin
  {zobrazi prazdnou krizovku}
  {zde melo byt spousta kontrol, diky pouziti ScrollBaru nejsou potreba}
  Self.VytvorPrazdnou(Self)
end;

procedure TForm1.VytvorPrazdnou(Sender: TObject);
var i, j: integer;
begin
  {odstrani uvodni dialog}
  PRadek := scRadek.Position;
  PSloupcu := scSloupcu.Position;
  Uvod.Visible := False;
  Vyrob.Visible := True;

  {nastavi velikost formulare a umisteni tlacitka}
  Form1.ClientHeight := Vyrob.Height + PRadek*Vyska +  3*Odsazeni;
  Form1.ClientWidth := PSloupcu*Sirka + 2*Odsazeni;
  Vyrob.Left := (Form1.ClientWidth - Vyrob.Width) div 2;
  Vyrob.Top := Odsazeni;

  {vyrobi policka krizovky}
  Form1.Caption := 'Vyrobna krizovek - vykresluji prazdnou krizovku';
  For i := 0 to PRadek-1 do
  For j := 0 to PSloupcu-1 do
  begin
    P[i, j] := TStaticText.Create(Self);
    P[i, j].Top := Vyrob.Height + Vyska*i +2*Odsazeni;
    P[i, j].Left := Odsazeni + Sirka*j;
    P[i, j].Height := Vyska;
    P[i, j].Width := Sirka;
    P[i, j].AutoSize := False;
    P[i, j].Parent := Self;
    If (i = 0) or (j = 0) then
      P[i, j].Color := BLegenda
    else
      P[i, j].Color := BPuvodni;
    P[i, j].BorderStyle := sbsSunken;
    P[i, j].Font.Name := 'Arial';
    P[i, j].Font.Size := VelikostPisma;
    P[i, j].Alignment := taCenter;
    P[i, j].Caption := '';
    P[i, j].Tag := PSloupcu*i + j;
    P[i, j].OnClick := ZacniSlovo;
    P[i, j].OnMouseDown := Zpet
  end;
  {s prvnim polickem nepujde hybat}
  P[0, 0].OnClick := Nelze;
  P[0, 0].OnMouseDown := NelzeTaky;

  {pripravi slovnik}
  Form1.Caption := 'Vyrobna krizovek - nacitam slovnik';
  PripravSlovnik;
  Form1.Caption := 'Vyrobna krizovek - zvolte si vzhled krizovky'
end;

{************** U P R A V A   V Z H L E D U   K R I Z O V K Y *****************}

procedure TForm1.Nelze(Sender: TObject);
begin
    {ShowMessage('Policka krizovky jiz nelze menit!');}
end;

procedure TForm1.NelzeTaky(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    {ShowMessage('Policka krizovky jiz nelze menit!');}
end;

procedure TForm1.ZacniSlovo(Sender: TObject);
var r,s : integer;
    PDolu, PDoprava, i: integer;
    Dolu, Doprava: boolean;
    Hotovo, Udelej: boolean;
    TDoprava, TDolu: String;
begin
  Dolu := False;
  Doprava := False;
  r := TStaticText(Sender).Tag div PSloupcu;
  s := TStaticText(Sender).Tag mod PSloupcu;

  If P[r, s].Color = BPuvodni then {udelej policko s legendou}
    P[r, s].Color := BLegenda
  else
    If P[r, s].Color = BLegenda then
    begin {udelej policko s tajenkou}
      P[r, s].Color := BTajenka;
      {zkontroluje, jestli muze jit dolu a doprava}
      If (s < (PSloupcu-1)) and ((P[r, s+1].Color = BPuvodni) or
         (P[r, s+1].Color = BPolTaj)) then
        Doprava := True;
      If (r < (PRadek-1)) and ((P[r+1, s].Color = BPuvodni) or
         (P[r+1, s].Color = BPolTaj)) then
        Dolu := True;
      {prislusna policka vybarvi}
      If (not Dolu) and (not Doprava) then
      begin
        ShowMessage('Okolo tohoto policka nejsou zadna volna pole k napsani tajenky!');
        P[r, s].Color := BLegenda;
        Exit
      end;
      PDolu := 0;
      PDoprava := 0;
      If Dolu then
        While (r+PDolu+1) < PRadek do
          If (P[r+PDolu+1, s].Color = BPuvodni) or (P[r+PDolu+1, s].Color = BPolTaj) then
          begin
            PDolu := PDolu + 1;
            If (P[r+PDolu, s].Color = BPolTaj) then
              P[r+PDolu, s].Color := BKrizTaj;
            If (P[r+PDolu, s].Color = BPuvodni) then
              P[r+PDolu, s].Color := BPolTaj
          end
          else
             Break;
      If Doprava then
        While (s+PDoprava+1) < PSloupcu do
          If (P[r, s+PDoprava+1].Color = BPuvodni) or (P[r, s+PDoprava+1].Color = BPolTaj) then
          begin
            PDoprava := PDoprava + 1;
            If (P[r, s+PDoprava].Color = BPolTaj) then
              P[r, s+PDoprava].Color := BKrizTaj;
            If (P[r, s+PDoprava].Color = BPuvodni) then
              P[r, s+PDoprava].Color := BPolTaj
          end
          else
             Break;
      {nacte od uzivatele tajenku}
      Form2.lbDoprava.Enabled := Doprava;
      Form2.edDoprava.Enabled := Doprava;
      Form2.lbDolu.Enabled := Dolu;
      Form2.edDolu.Enabled := Dolu;
      Form2.lbPDoprava.Caption := IntToStr(PDoprava);
      Form2.lbPDolu.Caption := IntToStr(PDolu);
      Form2.edDoprava.Text := '';
      Form2.edDolu.Text := '';
      Repeat
        Form2.ShowModal;
        TDoprava := Form2.edDoprava.Text;
        TDolu := Form2.edDolu.Text;
        Hotovo := True;
        If Doprava then
        begin
          If Length(TDoprava) <> PDoprava then
          begin
            Hotovo := False;
            ShowMessage('Tajenka smerem doprava neodpovida svou delkou!')
          end
          else
            For i:=1 to PDoprava do
              If P[r, s+i].Color = BKrizTaj then
                If P[r, s+i].Caption <> UpCase(TDoprava[i]) then
                begin
                  Hotovo := False;
                  ShowMessage('Tajenka smerem doprava se krizi s rozdilnym pismenem!');
                  Break
                end;
          If Hotovo then
            For i:=1 to Length(TDoprava) do
              If not (TDoprava[i] in CeskaAbeceda) then
              begin
                Hotovo := False;
                ShowMessage('Tajenka smerem doprava obsahuje nepovolene znaky!');
                Break
              end
        end;
        If Dolu and Hotovo then
        begin
          If Length(TDolu) <> PDolu then
          begin
            Hotovo := False;
            ShowMessage('Tajenka smerem dolu neodpovida svou delkou!')
          end
          else
            For i:=1 to PDolu do
              If P[r+i, s].Color = BKrizTaj then
                If P[r+i, s].Caption <> UpCase(TDolu[i]) then
                begin
                  Hotovo := False;
                  ShowMessage('Tajenka smerem dolu se krizi s rozdilnym pismenem!');
                  Break
                end;
          If Hotovo then
            For i:=1 to Length(TDolu) do
              If not (TDolu[i] in CeskaAbeceda) then
              begin
                Hotovo := False;
                ShowMessage('Tajenka smerem dolu obsahuje nepovolene znaky!');
                Break
              end
          end;
      Until Hotovo;
      {a zapise ji do policek}
      If Doprava then
      begin
        For i:=1 to PDoprava do
           P[r, s+i].Caption := VelkaPismena(TDoprava[i])
      end;
      If Dolu then
      begin
        For i:=1 to PDolu do
           P[r+i, s].Caption := VelkaPismena(TDolu[i])
      end
      {konec teto vetve !!!}
    end
    else
      If P[r, s].Color = BTajenka then
      begin {navrat puvodni bile policko}
        Udelej := True;
        If r > 0 then
        begin
           If (P[r-1, s].Color = BTajenka) or (P[r-1, s].Color = BKrizTaj) then
             Udelej := False
           else
             If P[r-1, s].Color = BPolTaj then
             begin
               i := 1;
               While (r-i > 0) and (P[r-i-1, s].Color = BPolTaj) do
                 i := i+1;
               If (r-i > 0) and ((P[r-i-1, s].Color = BTajenka)
                                    or (P[r-i-1, s].Color = BKrizTaj)) then
                 Udelej := False
             end
        end;
        If s > 0 then
        begin
           If (P[r, s-1].Color = BTajenka) or (P[r, s-1].Color = BKrizTaj) then
             Udelej := False
           else
             If P[r, s-1].Color = BPolTaj then
             begin
               i := 1;
               While (s-i > 0) and (P[r, s-i-1].Color = BPolTaj) do
                 i := i+1;
               If (s-i > 0) and ((P[r, s-i-1].Color = BTajenka)
                                    or (P[r, s-i-1].Color = BKrizTaj)) then
                 Udelej := False
             end
        end;
        If Udelej then
        begin
          P[r, s].Color := BPuvodni;
          PDoprava:=0;
          PDolu:=0;
          While (s+PDoprava+1) < PSloupcu do
            If (P[r, s+PDoprava+1].Color = BPolTaj) or (P[r, s+PDoprava+1].Color = BKrizTaj) then
            begin
              PDoprava := PDoprava + 1;
              If (P[r, s+PDoprava].Color = BPolTaj) then
              begin
                P[r, s+PDoprava].Color := BPuvodni;
                P[r, s+PDoprava].Caption := ''
              end;
              If (P[r, s+PDoprava].Color = BKrizTaj) then
                P[r, s+PDoprava].Color := BPolTaj
            end
            else
              Break;
          While (r+PDolu+1) < PRadek do
            If (P[r+PDolu+1, s].Color = BPolTaj) or (P[r+PDolu+1, s].Color = BKrizTaj) then
            begin
              PDolu := PDolu + 1;
              If (P[r+PDolu, s].Color = BPolTaj) then
              begin
                P[r+PDolu, s].Color := BPuvodni;
                P[r+PDolu, s].Caption := ''
              end;
              If (P[r+PDolu, s].Color = BKrizTaj) then
                P[r+PDolu, s].Color := BPolTaj
            end
            else
              Break
        end
        else
          ShowMessage('Tato tajenka je blokovana jinou tajenkou!')
      end
      else {nezmen barvu}
        ShowMessage('Toto je policko s tajenkou, nelze menit!')
end;

procedure TForm1.Zpet(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var r, s, i: integer;
    Udelej: boolean;
begin
  If Button = mbRight then
    If TStaticText(Sender).Color = BLegenda then
    begin
      r := TStaticText(Sender).Tag div PSloupcu;
      s := TStaticText(Sender).Tag mod PSloupcu;
      Udelej := True;
      If r > 0 then
      begin
         If (P[r-1, s].Color = BTajenka) or (P[r-1, s].Color = BKrizTaj) then
           Udelej := False
         else
           If P[r-1, s].Color = BPolTaj then
           begin
             i := 1;
             While (r-i > 0) and (P[r-i-1, s].Color = BPolTaj) do
               i := i+1;
             If (r-i > 0) and ((P[r-i-1, s].Color = BTajenka)
                                  or (P[r-i-1, s].Color = BKrizTaj)) then
               Udelej := False
           end
      end;
      If s > 0 then
      begin
         If (P[r, s-1].Color = BTajenka) or (P[r, s-1].Color = BKrizTaj) then
           Udelej := False
         else
           If P[r, s-1].Color = BPolTaj then
           begin
             i := 1;
             While (s-i > 0) and (P[r, s-i-1].Color = BPolTaj) do
               i := i+1;
             If (s-i > 0) and ((P[r, s-i-1].Color = BTajenka)
                                  or (P[r, s-i-1].Color = BKrizTaj)) then
               Udelej := False
           end
      end;
      If Udelej then
        TStaticText(Sender).Color := BPuvodni
      else
        ShowMessage('Toto policko nelze odebrat, nejdrive odeberte tajenku!')
    end
    else
      If TStaticText(Sender).Color = BTajenka then
        ZacniSlovo(Sender)
end;


{********************* V Y R O B A   K R I Z O V K Y *************************}

function TForm1.KontrolaSlov: boolean;
{spocita, kolik jak dlouhych slov bude potreba}
var RealPocet: array [1..MaxDelka] of integer;
    BylaTajenka: boolean;
    KNicemu: boolean;
    ADelka: integer;
    i, j: integer;
procedure VyresNicemu;
begin
    ShowMessage('Pozor, zde je slovo, ktere neni tajenkou, ale vsechna jeho pismena jsou urcena tajenkami!')
end;
procedure ZkoukniLegendu;
begin
    If ADelka > 0 then
    begin
        If not BylaTajenka then
            Inc(RealPocet[ADelka]);
        If KNicemu then
            VyresNicemu;
        ADelka := 0
    end;
    BylaTajenka := False;
    KNicemu := True
end;
procedure ZkoukniTajenku;
begin
    If ADelka > 0 then
    begin
        If not BylaTajenka then
            Inc(RealPocet[ADelka]);
        If KNicemu then
            VyresNicemu;
        ADelka := 0
    end;
    BylaTajenka := True;
    KNicemu := False
end;
procedure ZkoukniOstatni;
begin
    ADelka := ADelka + 1;
    If KNicemu and (P[i, j].Color = BPuvodni) then
        KNicemu := False
end;
procedure ZkoukniKonec;
begin
    ZkoukniLegendu
end;
begin
    {nastavi promenne}
    BylaTajenka := False;
    KNicemu := False;
    For i := 1 to MaxDelka do
       RealPocet[i] := 0;
    ADelka := 0;

    {projde radky}
    For i := 0 to PRadek-1 do
    begin
        For j := 0 to PSloupcu-1 do
        begin
            If P[i, j].Color = BLegenda then
                ZkoukniLegendu
            else
                If P[i, j].Color = BTajenka then
                    ZkoukniTajenku
                else
                   ZkoukniOstatni
        end;
        ZkoukniKonec
    end;

    {projde sloupce}
    ADelka := 0;
    For j := 0 to PSloupcu-1 do
    begin
        For i := 0 to PRadek-1 do
        begin
            If P[i, j].Color = BLegenda then
                ZkoukniLegendu
            else
                If P[i, j].Color = BTajenka then
                    ZkoukniTajenku
                else
                    ZkoukniOstatni
        end;
        ZkoukniKonec
    end;

    {zkontroluje, zda ma ve slovniku potrebna slova}
    {PRO VERZI SE ZAKAZANYM OPAKOVANIM SLOV!!!}
    KontrolaSlov := True;
    For i:= 1 to MaxDelka do
        If Pocet[i] < RealPocet[i] then
        begin
            KontrolaSlov := False;
            ShowMessage('Ve slovniku je nedostatek slov delky ' + IntToStr(i) + '!')
        end
end;

function TForm1.KontrolaModrychPoli: boolean;
var i: integer;
begin
   {zkontroluje, zda nektere policko v hornim ci levem okraji nezustalo bile}
   KontrolaModrychPoli := True;
   If P[0, 0].Color <> BLegenda then
   begin
     ShowMessage('Policko v hornim levem rohu musi zustat modre.');
     KontrolaModrychPoli := False;
     Exit
   end;
   For i:=1 to PRadek-1 do
     If (P[i, 0].Color <> BLegenda) and (P[i, 0].Color <> BTajenka) then
     begin
        ShowMessage('Vsechna policka v prvnim sloupci musi byt ' +
                'pro zacatek slova (modra) nebo pro zacatek tajenky (cervena)!');
        KontrolaModrychPoli := False;
        Exit
     end;
   For i:=1 to PSloupcu-1 do
     If (P[0, i].Color <> BLegenda) and (P[0, i].Color <> BTajenka) then
     begin
        ShowMessage('Vsechna policka v prvnim radku musi byt ' +
                'pro zacatek slova (modra) nebo pro zacatek tajenky (cervena)!');
        KontrolaModrychPoli := False;
        Exit
     end;
end;

procedure TForm1.VyrobDblClick(Sender: TObject);
var i, j: integer;
    R: array [0..MaxPRadek-1, 0..MaxPSloupcu-1] of TPolicko; {pomocne pole}
    SZS: PLegenda; {seznam zacatku slov}
    PomSZS, PredSZS : PLegenda; {pomocne ukazatele na nektery z prvku SZS}
    NDelka, NZbyva: integer; {aktualni stav delky a zbyva noveho slova}
    Pocitat: boolean; {Pocitat = True ... bude co pocitat}
    NovSlovo: MString;
    Nalezeno: boolean; {Nalezeno = True ... slovo ve slovniku nalezeno}
    Lze: boolean; {Lze = true ... toto slovo lze vlozit do krizovky}
    Prepis: boolean; {Prepis = true ... ma se prepsat aktualni slovo}
procedure UlozVypocet;
begin
    If NDelka < 0 then
    begin
        ShowMessage('Chyba programu!!! Slovo ma zapornou delku!');
        Exit
    end;
    If Pocitat then
    begin
        {zkopiruje vypocitanou delku a pocet zbyvajicich pismen do PredSZS}
        PredSZS^.delka := NDelka;
        PredSZS^.zbyva := NZbyva;
        {zaradi PredSZS na spravne misto do SZS}
        PomSZS := SZS;
        While PredSZS^.delka < PomSZS^.delka do
            PomSZS := PomSZS^.dalsi;
        PredSZS^.predchozi := PomSZS^.predchozi;
        PredSZS^.predchozi^.dalsi := PredSZS;
        PredSZS^.dalsi := PomSZS;
        PomSZS^.predchozi := PredSZS
    end;
    {vymaze prubezne vypocty}
    PredSZS := NIL;
    NDelka := 0;
    NZbyva := 0;
    Pocitat := False
end;
procedure ZkopirujZpet;
var i, j: integer;
begin
   {kontrola: zkopiruje obsah z pomocneho pole zpet do krizovky}
   For i := 0 to PRadek - 1 do
   For j := 0 to PSloupcu - 1 do
       If R[i, j].z <> '.' then
           P[i, j].Caption := R[i, j].z;
end;
procedure KontrolaSZS;
begin
   {kontrola: vypise seznam zacatku slov}
   PomSZS := SZS;
   ShowMessage('Pocatecni zarazka, Predchozi: '
                + IntToStr(integer (PomSZS^.predchozi)) + '.');
   PomSZS := PomSZS^.dalsi;
   While PomSZS^.dalsi <> NIL do
   begin
       ShowMessage('Radek: ' + IntToStr(PomSZS^.radek) +
                   ', Sloupec: ' + IntToStr(PomSZS^.sloupec) +
                   ', Doprava: ' + IntToStr(integer (PomSZS^.doprava)) +
                   ', Delka: ' + IntToStr(PomSZS^.delka) +
                   ', Zbyva: ' + IntToStr(PomSZS^.zbyva) + '.');
       PomSZS := PomSZS^.dalsi
   end;
   ShowMessage('Koncova zarazka, Dalsi: '
                + IntToStr(integer (PomSZS^.dalsi)) + '.');
   PomSZS := NIL
end;
begin
   {provede kontroly, odstrani tlacitko a znehybni policka krizovky}
   If not KontrolaModrychPoli then
       Exit;
   {If not KontrolaSlov then
       Exit;}
   Vyrob.Visible := False;
   Form1.Caption := 'Vyrobna krizovek - vytvarim krizovku, chvilenku strpeni';
   For i := 0 to PRadek - 1 do
   For j := 0 to PSloupcu - 1 do
   begin
       P[i, j].OnClick := Nelze;
       P[i, j].OnMouseDown := NelzeTaky;
   end;

   {vypise, kolik jak dlouhych slov ma k dispozici}
   {For i:=1 to MaxDelka do
      ShowMessage('Pocet slov: delka ' + IntToStr(i) + ': ' + IntToStr(Pocet[i]));}

   {zkopiruje obsah krizovky do pomocneho pole R}
   For i := 0 to PRadek - 1 do
   For j := 0 to PSloupcu - 1 do
   begin
       If P[i, j].Color = BPuvodni then
       begin
           R[i, j].z := Chr(0);
           R[i, j].k := 0;
       end
       else
           If P[i, j].Color = BPolTaj then
           begin
               R[i, j].z := (P[i, j].Caption)[1];
               R[i, j].k := 1;
           end
           else
               If P[i, j].Color = BKrizTaj then
               begin
                   R[i, j].z := (P[i, j].Caption)[1];
                   R[i, j].k := 2;
               end
               else
                  If (P[i, j].Color = BLegenda) or (P[i, j].Color = BTajenka) then
                  begin
                      R[i, j].z := '.';
                      R[i, j].k := -1;
                  end
   end;

   {vytvori a setridi SZS - seznam zacatku slov legendy - dle delky slov sestupne}
   {A. nejdrive si udela zarazky}
   PredSZS := New(PLegenda);
   PomSZS := New(PLegenda);
   PredSZS^.radek := -1;
   PomSZS^.radek := -1;
   PredSZS^.sloupec := -1;
   PomSZS^.sloupec := -1;
   PredSZS^.delka := MaxDelka;
   PomSZS^.delka := -1;
   PredSZS^.zbyva := MaxDelka;
   PomSZS^.zbyva := MaxDelka;
   PredSZS^.ukazobsah := NIL;
   PomSZS^.ukazobsah := NIL;
   PredSZS^.predchozi := NIL;
   PomSZS^.predchozi := PredSZS;
   PredSZS^.dalsi := PomSZS;
   PomSZS^.dalsi := NIL;

   {B. a nastavi si promenne}
   SZS := PredSZS;
   PredSZS := NIL;
   PomSZS := NIL;
   NDelka := 0;
   NZbyva := 0;
   Pocitat := False;

   {C. pak projde vsechny radky}
   For i := 0 to PRadek-1 do
   begin
       For j := 0 to PSloupcu-1 do
       begin
           If P[i, j].Color = BLegenda then
           begin
               UlozVypocet;
               If  j < PSloupcu - 1 then
                   If (P[i, j+1].Color <> BTajenka) and (P[i, j+1].Color <> BLegenda) then
                   begin
                       Pocitat := True;
                       PredSZS := New(PLegenda);
                       PredSZS^.radek := i;
                       PredSZS^.sloupec := j;
                       PredSZS^.doprava := True;
                       PredSZS^.ukazobsah := NIL
                   end
           end
           else
               If P[i, j].Color = BTajenka then
                   UlozVypocet
               else
                  If Pocitat then
                  begin
                      If P[i, j].Color = BPuvodni then
                      begin
                          Inc(NDelka);
                          Inc(NZbyva)
                      end
                      else
                         Inc(NDelka)
                  end
       end;
       UlozVypocet
   end;

   {D. a nakonec projde vsechny sloupce}
   For j := 0 to PSloupcu - 1 do
   begin
       For i := 0 to PRadek - 1 do
       begin
           If P[i, j].Color = BLegenda then
           begin
               UlozVypocet;
               If  i < PRadek - 1 then
                   If (P[i+1, j].Color <> BTajenka) and (P[i+1, j].Color <> BLegenda) then
                   begin
                       Pocitat := True;
                       PredSZS := New(PLegenda);
                       PredSZS^.radek := i;
                       PredSZS^.sloupec := j;
                       PredSZS^.doprava := False;
                       PredSZS^.ukazobsah := NIL
                   end
           end
           else
               If P[i, j].Color = BTajenka then
                   UlozVypocet
               else
                  If Pocitat then
                  begin
                      If P[i, j].Color = BPuvodni then
                      begin
                          Inc(NDelka);
                          Inc(NZbyva)
                      end
                      else
                         Inc(NDelka)
                  end
       end;
       UlozVypocet
   end;

   {vypise, kde zacinaji jak dlouha slova}
   {KontrolaSZS;}

   {zkontroluje, zda nektere slovo neni jiz cele vytvoreno a zda je ve slovniku}
   PomSZS := SZS;
   While PomSZS <> NIL do
   begin
       {pokud takove najde}
       If PomSZS^.zbyva = 0 then
       begin
           {tak si ho sestavi}
           NovSlovo := '';
           If PomSZS^.doprava then
           begin
               For i:= 1 to PomSZS^.delka do
                   NovSlovo := NovSlovo + R[PomSZS^.radek, PomSZS^.sloupec+i].z
           end
           else
           begin
               For i:= 1 to PomSZS^.delka do
                   NovSlovo := NovSlovo + R[PomSZS^.radek+i, PomSZS^.sloupec].z
           end;
           {a zkusi ho najit ve slovniku}
           Nalezeno := False;
           Konec[PomSZS^.delka] := Zacatek[PomSZS^.delka];
           While Konec[PomSZS^.delka] <> NIL do
           begin
               If Konec[PomSZS^.delka]^.s = NovSlovo then
               begin
                   Nalezeno := True;
                   Break
               end;
               Konec[PomSZS^.delka] := Konec[PomSZS^.delka]^.d
           end;
           If not Nalezeno then
               ShowMessage('Krizovka nelze vytvorit. Slovo ' + NovSlovo +
                  ', ktere je tvoreno pouze pismeny tajenek, neni ve slovniku.')
           {else
               ShowMessage('Upozorneni: v krizovce bylo slovo ' + NovSlovo +
                ' utvoreno pouze pismeny tajenky. Nastesti se vyskytuje ve slovniku.')}
       end;
       PomSZS := PomSZS^.dalsi
   end;
   PomSZS := NIL;

   {VLASTNI ALGORITMUS SESTAVENI KRIZOVKY}
   PomSZS := SZS;
   PomSZS := PomSZS^.dalsi;
   Prepis := False;
   {dokud se nedostane na konec ci na zacatek SZS}
   While (PomSZS^.dalsi <> NIL) and (PomSZS^.predchozi <> NIL) do
   begin
       {A. zvoli si slovo, ktere bude chtit do krizovky vlozit}
       {pokud zacina, nastavi si 1. slovo dane delky}
       If PomSZS^.ukazobsah = NIL then
       begin
           PomSZS^.ukazobsah := Zacatek[PomSZS^.delka];
                                 {je to pouze ukazatel na zaznam se slovem!!!!}
           If PomSZS^.ukazobsah = NIL then
           begin
               ShowMessage('Chyba slovniku!!! Chybi slova delky '
                            + IntToStr(PomSZS^.delka) + '!');
               Exit
           end;
       end
       else
       begin
           If Prepis then
           begin
               {vymaze soucasne slovo}
               If PomSZS^.doprava then
                   For i := 1 to PomSZS^.delka do
                   begin
                       If R[PomSZS^.radek, PomSZS^.sloupec + i].k = 2 then
                           R[PomSZS^.radek, PomSZS^.sloupec + i].k := 1
                       else
                          If R[PomSZS^.radek, PomSZS^.sloupec + i].k = 1 then
                          begin
                              R[PomSZS^.radek, PomSZS^.sloupec + i].z := Chr(0);
                              R[PomSZS^.radek, PomSZS^.sloupec + i].k := 0
                          end
                          else
                              ShowMessage('Spatna hodnota poctu krizeni: '
                              + IntToStr(R[PomSZS^.radek, PomSZS^.sloupec + i].k))
                   end
               else
               If not PomSZS^.doprava then
                   For i := 1 to PomSZS^.delka do
                   begin
                       If R[PomSZS^.radek + i, PomSZS^.sloupec].k = 2 then
                           R[PomSZS^.radek + i, PomSZS^.sloupec].k := 1
                       else
                          If R[PomSZS^.radek + i, PomSZS^.sloupec].k = 1 then
                          begin
                              R[PomSZS^.radek + i, PomSZS^.sloupec].z := Chr(0);
                              R[PomSZS^.radek + i, PomSZS^.sloupec].k := 0
                          end
                          else
                              ShowMessage('Spatna hodnota poctu krizeni: '
                              + IntToStr(R[PomSZS^.radek + i, PomSZS^.sloupec].k))
                   end;
               Prepis := False
           end;
           {pokud nezacina, posune se na dalsi slovo dane delky}
           PomSZS^.ukazobsah := PomSZS^.ukazobsah^.d;
           If PomSZS^.ukazobsah = NIL then
           begin
               {dalsi slovo dane delky uz neni, vrati se zpet}
               PomSZS := PomSZS^.predchozi;
               Prepis := True; {bude nutne vymazat slovo, ktere je uz v krizovce}
               Continue
           end
       end;
       Lze := True;

       {B. zkusi, zda se slovo hodi do krizovky}
       If PomSZS^.doprava then {jde doprava}
       begin
           For i := 1 to PomSZS^.delka do
               If R[PomSZS^.radek, PomSZS^.sloupec + i].z <> Chr(0) then
                   If R[PomSZS^.radek, PomSZS^.sloupec + i].z
                       <> PomSZS^.ukazobsah^.s[i] then
                   begin
                       Lze := False;
                       Break
                   end
       end
       else
           If not PomSZS^.doprava then {jde dolu}
           begin
               For i := 1 to PomSZS^.delka do
                   If R[PomSZS^.radek + i, PomSZS^.sloupec].z <> Chr(0) then
                       If R[PomSZS^.radek + i, PomSZS^.sloupec].z
                           <> PomSZS^.ukazobsah^.s[i] then
                       begin
                           Lze := False;
                           Break
                       end
           end;
       If not Lze then
       begin
           Prepis := False;
           Continue
       end;

       {C. vepise slovo do krizovky}
       If PomSZS^.doprava then
       begin
           For i := 1 to PomSZS^.delka do
               If R[PomSZS^.radek, PomSZS^.sloupec + i].z = Chr(0) then
               begin
                   R[PomSZS^.radek, PomSZS^.sloupec + i].z := PomSZS^.ukazobsah^.s[i];
                   R[PomSZS^.radek, PomSZS^.sloupec + i].k := 1;
               end
               else
               begin
                   {If R[PomSZS^.radek, PomSZS^.sloupec + i].z
                       <> PomSZS^.ukazobsah^.s[i] then
                       ShowMessage('Pocitac chce prepsat jiz vlozene pismeno!');}
                   R[PomSZS^.radek, PomSZS^.sloupec + i].k := 2
               end
       end
       else
       If not PomSZS^.doprava then
       begin
           For i := 1 to PomSZS^.delka do
               If R[PomSZS^.radek + i, PomSZS^.sloupec].z = Chr(0) then
               begin
                   R[PomSZS^.radek + i, PomSZS^.sloupec].z := PomSZS^.ukazobsah^.s[i];
                   R[PomSZS^.radek + i, PomSZS^.sloupec].k := 1;
               end
               else
               begin
                   {If R[PomSZS^.radek + i, PomSZS^.sloupec].z
                       <> PomSZS^.ukazobsah^.s[i] then
                       ShowMessage('Pocitac chce prepsat jiz vlozene pismeno!');}
                   R[PomSZS^.radek + i, PomSZS^.sloupec].k := 2
               end
       end;

       {pro kontrolu: po kazdem vepsani slova aktualizuje krizovku}
       {ZkopirujZpet;
       ShowMessage('Dalsi slovo pribylo do krizovky.');{}

       {D. zhodnoti, jestli napsanim slova nevzniklo nesmyslne slovo - dodelat!}

       {E. posune se dal}
       PomSZS := PomSZS^.dalsi;
       PomSZS^.ukazobsah := NIL;
       Prepis := False
   end;

   {vyhodnoti - lze nebo nelze vytvorit krizovku}
   If PomSZS^.dalsi = NIL then
   begin
       ZkopirujZpet;
       ShowMessage('Krizovka je hotova.')
   end
   else
       If PomSZS^.predchozi = NIL then
           ShowMessage('Vami pozadovana krizovka nelze vytvorit!');
   PomSZS := NIL;
   Form1.Caption := 'Vyrobna krizovek - krizovka hotova'
end;

end.
